pro correctlrisheaders, files, check=check, maxdt=maxdt, dir=dir

   print, 'old, use lriscorrectheaders instead'

   ; Look through all the raw LRIS files in this directory and correct headers with missing data via matching to the other member of the blue/red pair.

   ; should probably rename this - correct applies an error (not missing data)

   ; need to come up with a solution for jd/mjd since these are not guaranteed to be the same
 
   if n_elements(dir) eq 0 then dir = ''
   if n_elements(files) eq 0 then files = [file_search(dir+'b*_????.fits'),file_search(dir+'r*_????.fits')]
   if n_elements(files) eq 1 then if strpos(files,'*') ge 0 or strpos(files,'?') ge 0 then files = file_search(files)
   notblank = where(files ne '', ct)
   if ct eq 0 then return else files = files[notblank]
   
   nfiles = n_elements(files)

  ; usually missing:
  ; TARGNAME TELESCOP TELFOCUS TUBETEMP DOMEPOSN FLIMAGIN FLSPECTR DRA DDEC DTRACK ADCNEED CURRINST ADCPRENA
  ; usually also missing:
  ; RA ROTMODE ROTPOSN ROTPPOSN SECFOCUS SECTHETX SECTHETY SIMULATE 
  ; sometimes also missing:
  ; AIRMASS AZ DEC EL EQUINOX HA PONAME
  ; and occasionally it's even missing
  ; MJD-OBS ST DATE-OBS

   if n_elements(maxdt) eq 0 then maxdt = 900.

   lris = replicate({filename:'', ut:'', utf:0.D, object:'', camera:'', $
                     dec:'---', ra:'---', targname:'---', rotposn:!values.f_nan, domeazimuth:!values.f_nan},nfiles)
                  ;   airmass:0.D, az:0.D,  dec:'', el:0.D, equinox:0.D, ha:'', poname:'' $
                  ;   ra:'', rotmode:'', rotposn:0.D rotpposn:0.D, targname:'', telescop:'', telfocus:0.D, domeposN:0.D, flimagin:'', flspectr:''}, n_elements(files))
 
   for f = 0, n_elements(files)-1 do begin
     lris[f].filename = files[f]
     h = headfits(files[f], /silent)
     ;if f eq 0 then datestr = sxpar(h,'DATE')
     lris[f].ut = sxpar(h,'UTC')
     lris[f].utf = ten(sxpar(h,'UTC'))
     ;lris[f].mjd = sxpar(h,'MJD-OBS')
     lris[f].object = sxpar(h,'OBJECT',/silent)
     lris[f].camera = strmid(files[f],0,1)

     v = sxpar(h,'TARGNAME', count=ct)
     if ct ge 1 then lris[f].targname = v
     v = sxpar(h,'RA', count=ct)
     if ct ge 1 then lris[f].ra = v
     v = sxpar(h,'DEC', count=ct)
     if ct ge 1 then lris[f].dec = v
     v = sxpar(h,'ROTPOSN', count=ct)
     if ct ge 1 then lris[f].rotposn = v
     v = sxpar(h,'DOMEPOSN', count=ct)
     if ct ge 1 then lris[f].domeazimuth = v
   endfor


   for i = 0, 1 do begin
     if i eq 0 then begin
       ch = lris[where(lris.camera eq 'r')]
       comp = lris[where(lris.camera eq 'b')]
     endif else begin
       ch = lris[where(lris.camera eq 'b')]
       comp = lris[where(lris.camera eq 'r')]
     endelse

     for f = 0, n_elements(ch)-1 do begin
       if ch[f].targname eq '---' or ch[f].dec eq '---' or ch[f].ra eq '---' or finite(ch[f].rotposn) eq 0 or finite(ch[f].domeazimuth) eq 0 then begin
         dt = (comp.utf - ch[f].utf)*3600.D
         match = (where(abs(dt) eq min(abs(dt)) )) [0]
         mh = headfits(comp[match].filename)

         print, ch[f].filename,        '['+clip(ch[f].object)+'] matched by ', $
                 comp[match].filename, '['+clip(comp[match].object)+'] ', $
                 comp[match].ut+'-'+ch[f].ut+' = '+clip(dt[match])+'s'
         if abs(dt[match]) gt 90 then begin
           print, '  Times differ significantly.'
           if abs(dt[match]) gt maxdt then continue
         endif
         if comp[match].targname eq '---' then begin
           print, '  Match is also missing header data!'
           continue
         endif


         h = headfits(ch[f].filename)
         inhnote = 'Inherited from '+removepath(comp[match].filename)
         if ch[f].targname eq '---' or finite(ch[f].domeazimuth) eq 0 then begin
            print, '   TARGNAME --> ', sxpar(mh,'TARGNAME')
            sxaddpar, h, 'TARGNAME', sxpar(mh,'TARGNAME'), inhnote
            sxaddpar, h, 'TELESCOP', sxpar(mh,'TELESCOP'), inhnote
            sxaddpar, h, 'TELFOCUS', sxpar(mh,'TELFOCUS'), inhnote
            sxaddpar, h, 'TUBETEMP', sxpar(mh,'TUBETEMP'), inhnote
            sxaddpar, h, 'DOMEPOSN', sxpar(mh,'DOMEPOSN'), inhnote
            sxaddpar, h, 'FLIMAGIN', sxpar(mh,'FLIMAGIN'), inhnote
            sxaddpar, h, 'FLSPECTR', sxpar(mh,'FLSPECTR'), inhnote
            sxaddpar, h, 'DRA', sxpar(mh,'DRA'), inhnote
            sxaddpar, h, 'DDEC', sxpar(mh,'DDEC'), inhnote
            sxaddpar, h, 'DTRACK', sxpar(mh,'DTRACK'), inhnote
            sxaddpar, h, 'ADCNEED', sxpar(mh,'ADCNEED'), inhnote
            sxaddpar, h, 'CURRINST', sxpar(mh,'CURRINST'), inhnote
            sxaddpar, h, 'ADCPRENA', sxpar(mh,'ADCPRENA'), inhnote
         endif
         if ch[f].ra eq '---' or finite(ch[f].rotposn) eq 0 then begin ; should split this
            print, '        RA --> ', sxpar(mh,'RA')
            print, '   ROTPOSN --> ', sxpar(mh,'ROTPOSN')
            sxaddpar, h, 'RA', sxpar(mh,'RA'), inhnote
            sxaddpar, h, 'ROTMODE', sxpar(mh,'ROTMODE'), inhnote
            sxaddpar, h, 'ROTPOSN', sxpar(mh,'ROTPOSN'), inhnote
            sxaddpar, h, 'ROTPPOSN', sxpar(mh,'ROTPPOSN'), inhnote
            sxaddpar, h, 'SECFOCUS', sxpar(mh,'SECFOCUS'), inhnote
            sxaddpar, h, 'SECTHETX', sxpar(mh,'SECTHETX'), inhnote
            sxaddpar, h, 'SECTHETY', sxpar(mh,'SECTHETY'), inhnote
            sxaddpar, h, 'SIMULATE', sxpar(mh,'SIMULATE'), inhnote
         endif
         if ch[f].dec eq '---' then begin
            print, '   AIRMASS --> ', sxpar(mh,'AIRMASS')
            print, '       DEC --> ', sxpar(mh,'DEC')
            sxaddpar, h, 'AIRMASS', sxpar(mh,'AIRMASS'), inhnote
            sxaddpar, h, 'AZ', sxpar(mh,'AZ'), inhnote
            sxaddpar, h, 'DEC', sxpar(mh,'DEC'), inhnote
            sxaddpar, h, 'EL', sxpar(mh,'EL'), inhnote
            sxaddpar, h, 'EQUINOX', sxpar(mh,'EQUINOX'), inhnote
            sxaddpar, h, 'HA', sxpar(mh,'HA'), inhnote
            sxaddpar, h, 'PONAME', sxpar(mh,'PONAME'), inhnote
         endif
         if keyword_set(check) eq 0 then $
            modfits, ch[f].filename, 0, h, exten=0
       endif
     endfor
   endfor




end
