function strnum, instr, let=let, quiet=quiet
  n = n_elements(instr)
  if n eq 0 then let = '' else let = strarr(n)
  if n eq 0 then num = 0.0d else num = dblarr(n)

  for i = 0, n-1 do begin
    str = strtrim(instr[i],2)
    l = strlen(str)
    numstr = ''
    letstr = ''
    ndigit = 0
    for c = 0, l-1 do begin
        ch = strmid(str,c,1)
        digit   = (ch ge '0' and ch le '9')
        numchar = (ch ge '0' and ch le '9') or ch eq '.' or ch eq '-' or ch eq '+' or ((ch eq 'e' or ch eq 'E' or ch eq 'd' or ch eq 'D') and c gt 0)
        if numchar then numstr = numstr + ch $
                   else letstr = letstr + ch
        if digit then ndigit += 1
    endfor

    if ndigit eq 0 then begin
      if keyword_set(quiet) eq 0 then print, 'WARNING:  strnum argument ', instr[i], ' has no numeric characters.'
      if n eq 0 then return, !values.f_nan ; formerly zero, hopefully this doesn't cause problems
      let[i] = letstr ; don't remember what this does
      num[i] = !values.f_nan
      continue
    endif

    let[i] = letstr
    num[i] = double(numstr)
  endfor
  if n eq 1 then return, num[0]
  return, num
end

