pro symplot, x, y, err=err, sym=sym, fill=fill, size=size, thick=thick, norm=norm
                               ;sym=-1 means use current usersym
  ; fill and size must be scalars.  sym can be a vector.

  ax = [x]
  ay = [y]  
  if (keyword_set(size) eq 0) then size = 1
  if n_elements(sym) eq 1 and n_elements(ax) gt 1 then $
    sym = replicate(sym,n_elements(ax))


  if n_elements(sym) eq 0 then begin
     ;oplot, ax, ay, psym=8
     if keyword_set(norm) then plots, ax, ay, psym=8, norm=norm, thick=thick $
                          else oplot, ax, ay, psym=8, thick=thick
  endif else begin
    for s = -1, 14 do begin
      ws = where(sym eq s, cw)
      if cw eq 0 then continue
      if s ge 0 and s le 8 then plotsym, s, size, fill=fill, thick=thick  
      sc=1.3*size
      if s eq 4 then $  ; down triangle
         usersym, [-1,0,1,-1]*sc,[-0.577,1.154,-0.577,-0.577]*sc, fill=fill, thick=thick
      if s eq 5 then $  ; up triangle
         usersym, [-1,0,1,-1]*sc,[0.577,-1.154,0.577,0.577]*sc, fill=fill, thick=thick

      if s eq 9 then $  ;diamond
        usersym, [0,1,0,-1,0]*sc, [-1,0,1,0,-1]*sc, fill=fill, thick=thick
      if s eq 10 then $ ;X
        usersym, [0,0.5,1,0.5,1,0.5,0,-0.5,-1,-0.5,-1,-0.5,0]*sc,$
                 [0.5,1,0.5,0,-0.5,-1,-0.5,-1,-0.5,0,0.5,1,0.5]*sc,$
                 fill=fill, thick=thick
      if s eq 11 then $ ;hexagon
        usersym, [0,0.866,0.866,0,-0.866,-0.866,0]*sc, [1,0.5,-0.5,-1,-0.5,0.5,1]*sc,fill=fill, thick=thick
      if s eq 12 then $
         usersym, [0.577,-1.154,0.577,0.577]*sc, [-1,0,1,-1]*sc, fill=fill, thick=thick
        ;usersym, [-0.452,-0.452,0.872,-0.452]*sc, [-0.75,0.75,0,-0.75]*sc,fill=fill
      if s eq 13 then $
         usersym, [-0.577,1.154,-0.577,-0.577]*sc, [-1,0,1,-1]*sc, fill=fill, thick=thick
        ;usersym, [0.4,0.4,-0.6,0.4]*sc, [-0.5,0.5,0,-0.5]*sc,fill=fill
      ;oplot, ax[ws], ay[ws], psym=8
      if s eq 14 then $
         usersym, [-1.1,-0.3,0,0.3,1.1,0.2,0,-0.3,-1.1]*sc,$
                  [0,0.3,1.1,0.3,0,-0.3,-1.1,-0.3,0]*sc, fill=fill, thick=thick



      if keyword_set(norm) then plots, ax[ws], ay[ws], psym=8, thick=thick, norm=norm $
                                else oplot, ax[ws], ay[ws], psym=8, thick=thick
    endfor
  endelse

  if (keyword_set(err)) then begin
    errplot, ax, ay-err, ay+err 
  endif

end
