; -----------
function loadobjectposfile, objectfile, ct=ct

   tt = 0
   if file_test(objectfile) gt 0 then begin 
      ntr = countlines(objectfile)
      tr = replicate({file:'', ymin:0., ymax:0., yfix:-1., aprad:0., bakmin:[0.,0.], bakmax:[0.,0], tracefile:'', tracefileypos:0., apname:'', addsky:0},ntr)

      openr, 9, objectfile
      inline = ''
      for t = 0, ntr-1 do begin
          readf, 9, inline
          hashpos = strpos(inline,'#')
          if hashpos ge 0 then inline = strmid(inline,0,hashpos)
          inline = clip(inline)
          if strlen(inline) eq 0 then continue
          inline = repstr(repstr(inline,'(',' '),')','')  ; makes compatible with old format
          inarr = strsplit(inline,/extract)
          if n_elements(inarr) lt 3 then continue   ; the radius is now required information
          tr[tt].file = inarr[0]
          if strpos(tr[tt].file,'|') gt 0 then begin
              ininarr = strsplit(tr[tt].file,'|',/extract)
              tr[tt].file = ininarr[0]
              tr[tt].apname = ininarr[1]
          endif
          tr[tt].yfix = inarr[1]
          tr[tt].aprad = inarr[2]
          if n_elements(inarr) ge 4 then begin
            ; background region, which can be asymmetric:  e.g., 10-15|12-19
            if strpos(inarr[3],'*') gt 0 then begin    ; * means don't use the 2D sky subtraction
              tr[tt].addsky = 1                        ;   when extracting
              inarr[3] = repstr(inarr[3],'*','')
            endif
            if inarr[3] ne '' then begin
              barr = strsplit(inarr[3],'|',/extract)
              if n_elements(barr) eq 1 then barr = [barr[0],barr[0]]
              for b = 0, n_elements(barr)-1 do begin
                 bdarr = strsplit(barr[b],'-',/extract)
                 tr[tt].bakmin[b] = float(bdarr[0])
                 if n_elements(bdarr) gt 1 then tr[tt].bakmax[b] = float(bdarr[1])
              endfor
            endif
          endif
          if n_elements(inarr) ge 5 then begin
            tr[tt].tracefile = inarr[4]
          endif else begin
            tr[tt].tracefile = repstr(tr[tt].file, '.fits','.trace')
          endelse
          tt += 1
      endfor
      close, 9
      if tt ge 1 then tr = tr[0:tt-1] ; ignore unfilled lines
   endif else begin
       tr = ''
   endelse
   ct = tt

   return, tr
end

